// 
class ArcSegment {
  float arcstart, extent;
  int gen, i, clr;
  float rs, re;


  ArcSegment(float arcstart, float extent, int gen, float rs, float re, int clr) {

    this.arcstart = arcstart;
    this.extent = extent;
    this.gen = gen;
    this.rs=rs;
    this.re =re;
    this.clr =clr;
  }

  //source: http://www.shiffman.net/2011/02/03/rotate-a-vector-processing-js/

  void rotate2D(PVector v, float ang) {
    //calculate magnitude and angle of vector v
    float m = v.mag();
    float a = v.heading();

    a = a+ang;
    v.x = m*cos(a);
    v.y = m*sin(a);
  }

  void render() 
  {
    stroke(250);
    strokeWeight(0.5);
    fill(Clr[gen][clr]);

    if (set == false) {
      if (gen == 0)
        arc(centerx, centery, 2*(0.75+extent*9)*radius, 2*(0.75+extent*9)*radius, arcstart*TWO_PI, (arcstart+extent)*TWO_PI);
      else
      {
        arc(centerx, centery, 2*(0.75+re*9+extent*9)*radius, 2*(0.75+re*9+extent*9)*radius, (arcstart*re+rs)*TWO_PI, (rs+(arcstart+extent)*re)*TWO_PI);
      }
    } else if (changeD <10)
    {
      if (gen == 1)
      {
        arc(centerx, centery, 2*(0.75+extent*6)*radius, 2*(0.75+extent*6)*radius, arcstart*TWO_PI, (arcstart+extent)*TWO_PI);
        PVector v = new PVector(radius, 0);
        rotate2D(v, arcstart*TWO_PI);
        line(centerx+0.75*v.x, centery+0.75*v.y, centerx+v.x*(0.75+extent*6), centery+v.y*(0.75+extent*6));
      } 
      else
      {
        arc(centerx, centery, 2*(0.75+re*6+extent*6)*radius, 2*(0.75+re*6+extent*6)*radius, (arcstart*re+rs)*TWO_PI, (rs+(arcstart+extent)*re)*TWO_PI);
        PVector v = new PVector(radius, 0);
        rotate2D(v, (arcstart*re+rs)*TWO_PI);
        line(centerx+(0.75+re*6)*v.x, centery+(0.75+re*6)*v.y, centerx+v.x*(0.75+re*6+extent*6), centery+v.y*(0.75+re*6+extent*6));
      }
      // lines to connect arcs
      //rotate2D(v, (rs+(arcstart+extent)*re)*TWO_PI);
      //line(centerx+(0.75+re*6)*v.x, centery+(0.75+re*6)*v.y, centerx+v.x*(0.75+re*6+extent*6), centery+v.y*(0.75+re*6+extent*6));
    } else
    {
      if (gen == 2)
        arc(centerx, centery, 2*(0.75+extent*9)*radius, 2*(0.75+extent*9)*radius, arcstart*TWO_PI, (arcstart+extent)*TWO_PI);

      PVector v = new PVector(radius, 0);
      rotate2D(v, arcstart*TWO_PI);
      line(centerx+0.75*v.x, centery+0.75*v.y, centerx+v.x*(0.75+extent*9), centery+v.y*(0.75+extent*9));
      //rotate2D(v, (arcstart+extent)*TWO_PI);
      //line(centerx+0.75*v.x, centery+0.75*v.y, centerx+v.x*(0.75+extent*9), centery+v.y*(0.75+extent*9));
    }
  }
}